package com.unipi.talepis.a8thapp;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.google.android.gms.tasks.OnCompleteListener;
import com.google.android.gms.tasks.Task;
import com.google.firebase.auth.AuthResult;
import com.google.firebase.auth.FirebaseAuth;
import com.google.firebase.auth.FirebaseUser;
import com.google.firebase.auth.UserProfileChangeRequest;

public class MainActivity extends AppCompatActivity {
    private FirebaseAuth mAuth;
    EditText editText1,editText2,editText3;
    TextView textView1;
    FirebaseUser currentUser;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        mAuth = FirebaseAuth.getInstance();
        editText1 = findViewById(R.id.editTextTextPersonName);
        editText2 = findViewById(R.id.editTextTextPassword);
        editText3 = findViewById(R.id.editTextTextPersonName2);
        textView1 = findViewById(R.id.textView);
    }
    public void signup(View view){
        mAuth.createUserWithEmailAndPassword(
                editText1.getText().toString(),editText2.getText().toString())
                .addOnCompleteListener(this, new OnCompleteListener<AuthResult>() {
                    @Override
                    public void onComplete(@NonNull Task<AuthResult> task) {
                        if (task.isSuccessful()){
                            Toast.makeText(getApplicationContext(),"Signup success!",Toast.LENGTH_LONG).show();
                            currentUser = mAuth.getCurrentUser();
                            textView1.setText(currentUser.getUid());
                            changeUserProfile(editText3.getText().toString(),
                                    "https://thumbs.gfycat.com/SharpCookedGiraffe-size_restricted.gif",
                                    currentUser);
                        } else {
                            Toast.makeText(getApplicationContext(),
                                    task.getException().getMessage(),Toast.LENGTH_LONG).show();
                        }
                    }
                });
    }
    public void signin(View view){
        mAuth.signInWithEmailAndPassword(
                editText1.getText().toString(),editText2.getText().toString())
                .addOnCompleteListener(this, new OnCompleteListener<AuthResult>() {
                    @Override
                    public void onComplete(@NonNull Task<AuthResult> task) {
                        if (task.isSuccessful()){
                            currentUser = mAuth.getCurrentUser();
                            textView1.setText(currentUser.getUid());
                            Toast.makeText(getApplicationContext(),"Login success!",Toast.LENGTH_LONG).show();
                            Intent intent = new Intent(getApplicationContext(),MainActivity2.class);
                            intent.putExtra("username",currentUser.getDisplayName());
                            
                            intent.putExtra("imageUri",currentUser.getPhotoUrl().toString());
                            startActivity(intent);
                        }else {
                            Toast.makeText(getApplicationContext(),
                                    task.getException().getMessage(),Toast.LENGTH_LONG).show();
                        }
                    }
                });
    }
    private void changeUserProfile(String username, String imagePath, FirebaseUser user){
        UserProfileChangeRequest profileChangeRequest = new UserProfileChangeRequest.Builder()
                .setDisplayName(username)
                .setPhotoUri(Uri.parse(imagePath))
                .build();
        user.updateProfile(profileChangeRequest)
                .addOnCompleteListener(new OnCompleteListener<Void>() {
                    @Override
                    public void onComplete(@NonNull Task<Void> task) {
                        Toast.makeText(getApplicationContext(),"User profile updated",Toast.LENGTH_LONG).show();
                    }
                });
    }
}